/*

widget by Matt Sephton <http://www.gingerbeardman.com/ceefaxviewer/>
thanks to www.ceefax.tv

*/

var maxSubs;
var myResults;
var currentURL, previousURL;
var frontHidden;
var channel;
var page;
var starter;
var refreshDelay;
var jumpViewing;

var domain = "http://www.ceefax.tv";

/* MAIN */

function initCeefax() {
    if (window.widget) {
		var serviceString = widget.preferenceForKey('serviceString');

		if (serviceString && serviceString.length > 0) {
			channel = serviceString;
		} else {
			channel = "bbc1";
		}

		starter = widget.preferenceForKey('startPage');
		//alert(starter +" "+ parseInt(starter));

		if (starter == null) {
			starter = 100;
		}
		page = starter;

		refreshDelay = widget.preferenceForKey('refreshDelay');
		//if (refreshDelay == null) {
		//	refreshDelay = 1500;
		//}
    }
	
	setPrefs();

    goStart();
    //goHome()
}

function changeURL(channel, pageURL) {
    //alert(pageURL);
    if (pageURL != currentURL) previousURL = currentURL;
    currentURL = pageURL;

    /* fetch page */
    var html = new XMLHttpRequest();
    html.open("GET", pageURL, false);
    html.setRequestHeader("Cache-Control", "no-cache");
    html.onreadystatechange = function() {
	if (html.readyState == 4) {
	    if (html.status == 200) {
			//alert("xmlhttprequest: status 200 (OK)");
			myResults = html.responseText;
	    } else {
			alert("xmlhttprequest: problem getting html page\n" + html.statusText);
			document.getElementById('defaultImage').src = 'Offline.png';
	    }
	}
    }
    html.send(null);

    //non existant page check
    var badPage = html.responseText.match("is not available");
    if (badPage != null) {
		goHome();
		return;
    }

    /* get subpages table cell */
    matches = myResults.match(/<TD ALIGN=RIGHT([\n\w\W]*)<\/TD>\n<\/TR>\n<\/TABLE BORDER>/m);
    maxSubs = matches[0];
    maxSubs = maxSubs.replace(/<\S[^>]*>/g,"");		    /* strip tags */
    maxSubs = maxSubs.replace(/^\s*|\s*$/g,"");		    /* trim white space */
    maxSubs = maxSubs.substr(maxSubs.lastIndexOf(' ')+1, maxSubs.length - maxSubs.lastIndexOf(' '));
    if (parseInt(maxSubs) > 0) {
		document.getElementById('subnav').style.visibility = 'visible';
    } else {
		document.getElementById('subnav').style.visibility = 'hidden';
    }
    //alert(parseInt(maxSubs));

    /* get screen display table */
    matches = myResults.match(/<TABLE BORDER=0([\n\w\W]*)<\/TABLE>/m);
    myResults = matches[0];

    /* replace some html */
    myResults = myResults.replace(/\/cgi-bin\/gfx.cgi/g, domain + '/cgi-bin/gfx.cgi');
    myResults = myResults.replace(/\/txtmaster.php/g, domain + '/txtmaster.php');
    myResults = myResults.replace(/A HREF="javascript:/g, 'onclick=\"');
    myResults = myResults.replace(/A HREF="mailto:/g, 'onclick=\"mailto:');

    /* remove mouse events */
    myResults = myResults.replace(/ onMouseOver[^>]+/g, "");

    //alert(myResults);

    /* display modified html */
    document.getElementById('results').innerHTML = myResults;
    if (refreshDelay != null) {
		setTimeout(goRefresh, refreshDelay);
    }
}

/* NAV */

function goHome() {
	changeURL(channel, domain + '/txtmaster.php?page=100&subpage=0&channel=' + channel + '&search_string=&fontsize=1');
}

function goStart() {
	changeURL(channel, domain + '/txtmaster.php?page=' + starter + '&subpage=0&channel=' + channel + '&search_string=&fontsize=1');
}

function goRefresh() {
    changeURL(channel, currentURL);
}

function goBack() {
	changeURL(channel, previousURL);
}

function goSubpage(dir) {
	var first, second, currentSubpage, nextSubpage, nextURL;

	first = currentURL.indexOf("&subpage") + 9;
	second = currentURL.indexOf("&channel");
	currentSubpage = currentURL.substr(first, second-first);

	if (currentSubpage == 0) currentSubpage = 1;

	nextSubpage = parseInt(currentSubpage) + dir;
	if (nextSubpage > maxSubs) nextSubpage = 1;
	if (nextSubpage < 1) nextSubpage = maxSubs;

	nextURL = currentURL.substr(0, first) + nextSubpage + currentURL.substr(second, currentURL.length - first);
	changeURL(channel, nextURL);
}

function goPage(dir) {
	var first, second, currentPage, nextPage, nextURL;

	first = currentURL.indexOf("?page") + 6;
	second = currentURL.indexOf("&subpage");
	currentPage = currentURL.substr(first, second-first);

	nextPage = parseInt(currentPage) + dir;
	if (nextPage > 999) nextPage = 100;
	if (nextPage < 100) nextPage = 999;

	nextURL = currentURL.substr(0, first) + nextPage + currentURL.substr(second, currentURL.length - first);
	//reset subpage
	nextURL = nextURL.replace(/subpage\=[0-9]+/g, "subpage\=0");
	changeURL(channel, nextURL);

	page = nextPage;
}

function goJump(p) {
	var first, second, currentPage, nextPage, nextURL;
	nextPage = parseInt(p);

	if (nextPage >= 100) {
		first = currentURL.indexOf("?page") + 6;
		second = currentURL.indexOf("&subpage");
		currentPage = currentURL.substr(first, second-first);

		nextURL = currentURL.substr(0, first) + nextPage + currentURL.substr(second, currentURL.length - first);
		//reset subpage
		nextURL = nextURL.replace(/subpage\=[0-9]+/g, "subpage\=0");
		changeURL(channel, nextURL);
	}
	hideJump();

	page = nextPage;
}

function showJump() {
    document.getElementById('searchBack').style.visibility = 'visible';
    document.getElementById('searchBar').style.visibility = 'visible';
    document.getElementById('searchInput').value = '';
    document.getElementById('searchInput').focus();

    jumpViewing = true;
}

function hideJump() {
    document.getElementById('searchBar').style.visibility = 'hidden';
    document.getElementById('searchBack').style.visibility = 'hidden';

    jumpViewing = false;
}

/* PREFERENCE RELATED */

function setPrefs() {
	switch (channel) {
	case "bbc1":
		document.getElementById('selector').options[0].selected = true;
		break;
	case "bbc2":
		document.getElementById('selector').options[1].selected = true;
		break;
	case "aertel":
		document.getElementById('selector').options[2].selected = true;
		break;
	}

	document.getElementById('startPage').value = starter;

	frontHidden = true;
	checkForUpdates();
}

function changeService(elem) {
	switch (parseInt(elem.options[elem.selectedIndex].value)) {
	case 1:
		if (window.widget) {
			widget.setPreferenceForKey('bbc1', 'serviceString');
			channel = 'bbc1';
		}
		break;
	case 2:
		if (window.widget) {
			widget.setPreferenceForKey('bbc2', 'serviceString');
			channel = 'bbc2';
		}
		break;
	case 3:
		if (window.widget) {
			widget.setPreferenceForKey('aertel', 'serviceString');
			channel = 'aertel';
		}
		break;
	}
}

function btnDone() {
    starter = parseInt(document.getElementById('startPage').value);
//	alert(starter);
    if (starter > 100) {
		if (window.widget) widget.setPreferenceForKey(starter, 'startPage');
    } else {
		starter = 100;
    }

    if (refreshDelay != null && refreshDelay != 1500) {
		if (window.widget) widget.setPreferenceForKey(refreshDelay, 'refreshDelay');
    }

    frontHidden = false;
}

/* VERSION CHECKING */

var req;
var versionNumber = 14;

function checkForUpdates() {
    var lastDate = new Date()
    lastDate = widget.preferenceForKey('lastUpdateCheck');
    var diff = daysBetween( Date.parse(lastDate), Date.parse(Date()) );
    //alert(diff);

    var versionDisplay = versionNumber / 10;
    versionDisplay += '';
    if (versionDisplay.indexOf(".") == -1) versionDisplay = versionDisplay + ".0";
    document.getElementById('version').innerHTML = versionDisplay;

    //only check for update once a week
    if (diff > 0 && diff < 7) {
	showVersion(versionNumber);
	alert("Checked version of widget "+diff+" days ago - too soon to check again.");
	return;
    }

    /* fetch page */
    var req = new XMLHttpRequest();
    req.open("GET", 'http://www.gingerbeardman.com/ceefaxviewer/version.txt', false);
    req.setRequestHeader("Cache-Control", "no-cache");
    req.onreadystatechange = function() {
	if (req.readyState == 4) {
	    if (req.status == 200) {
			showVersion(req.responseText);
	    }
	}
    }
    req.send(null);
    alert("Website says latest version is "+ req.responseText);

    if (diff >= 7 || lastDate == null) {
		if (window.widget) widget.setPreferenceForKey(Date(), 'lastUpdateCheck');
    }
}

function showVersion(v) {
	if (v < versionNumber) {
		document.getElementById('update').innerHTML = 'You are using a development version';
	} else if (v > versionNumber) {
		var updateButton = document.getElementById('update');
		updateButton.innerHTML = "";
		createGenericButton (updateButton, 'DOWNLOAD NEW VERSION', updateWidget, 70);
	} else {
		document.getElementById('update').innerHTML = 'You are using the latest version';
	}
}

function updateWidget() {
	widget.openURL('http://www.gingerbeardman.com/ceefaxviewer/ceefaxviewer.zip');
}

/* HOT KEYS */

document.addEventListener("keyup", keyReleased, true);

function keyReleased(event) {
	if (event.metaKey || jumpViewing == true) return;

	switch (event.charCode) {
	case 71:		/* G */
	case 103:	/* g */
	case 74:		/* J */
	case 106:	/* j */
		showJump();
		break;

	case 72:		/* H */
	case 104:	/* h */
		goHome();
		break;

	case 73:		/* I */
	case 105:	/* i */
		if (!frontHidden) {
			setPrefs();
			showPrefs(event);
		}
		break;

	case 82:		/* R */
	case 114:	/* r */
		goRefresh();
		break;

	case 83:		/* S */
	case 115:	/* s */
		goStart();
		break;

	case 63235:		/* cursor right */
		goPage(+1);
		break;

	case 63234:		/* cursor left */
		goPage(-1);
		break;

	case 63232:		/* cursor up */
		goSubpage(-1);
		break;

	case 63233:		/* cursor down */
		goSubpage(+1);
		break;

	case 8:			/* backspace */
		goBack();
		break;

	case 48:			/* set bookmark, 1-0 */
	case 49:
	case 50:
	case 51:
	case 52:
	case 53:
	case 54:
	case 55:
	case 56:
	case 57:
		if (document.getElementById('searchBar').style.visibility == 'hidden') {
			bookmarkNumber = (event.charCode-48);
			//alert('set bookmark'+ bookmarkNumber +"="+ page);
			if (window.widget) widget.setPreferenceForKey(page, 'bookmark'+ bookmarkNumber);
		}
		break;

	case 63236:			/* get bookmark, F1-F10 */
	case 63237:
	case 63238:
	case 63239:
	case 63240:
	case 63241:
	case 63242:
	case 63243:
	case 63244:
	case 63245:
		bookmarkNumber = (event.charCode-63235) % 10;
		//alert('get bookmark'+ bookmarkNumber +"="+ widget.preferenceForKey('bookmark'+ bookmarkNumber) );
		if (window.widget) goJump(widget.preferenceForKey('bookmark'+ bookmarkNumber) );
		break;

	default:
		//alert(event.charCode);
	}

	event.stopPropagation();
	event.preventDefault();
}

function daysBetween(date1, date2) {
    // The number of milliseconds in one day
    var ONE_DAY = 1000 * 60 * 60 * 24;

    // Calculate the difference
    var difference = Math.abs(date1 - date2);

    // Convert back to days and return
    return Math.round(difference/ONE_DAY);
}